searchNodes=[{"doc":"Official client to use HTTP polling for firmware updates from NervesHub","ref":"NervesHubLinkHTTP.html","title":"NervesHubLinkHTTP","type":"module"},{"doc":"Apply the update at the provided url.","ref":"NervesHubLinkHTTP.html#apply_update/1","title":"NervesHubLinkHTTP.apply_update/1","type":"function"},{"doc":"Check for an available update and automatically apply it.","ref":"NervesHubLinkHTTP.html#update/1","title":"NervesHubLinkHTTP.update/1","type":"function"},{"doc":"Check for an available update. The update is not automatically applied.","ref":"NervesHubLinkHTTP.html#update?/1","title":"NervesHubLinkHTTP.update?/1","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Certificate.html","title":"NervesHubLinkHTTP.Certificate","type":"module"},{"doc":"","ref":"NervesHubLinkHTTP.Certificate.html#ca_certs/0","title":"NervesHubLinkHTTP.Certificate.ca_certs/0","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Certificate.html#fwup_public_keys/0","title":"NervesHubLinkHTTP.Certificate.fwup_public_keys/0","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Certificate.html#pem_to_der/1","title":"NervesHubLinkHTTP.Certificate.pem_to_der/1","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Certificate.html#public_keys/0","title":"NervesHubLinkHTTP.Certificate.public_keys/0","type":"function"},{"doc":"A behaviour module for customizing the tool used for HTTP requests to NervesHub. Also allows handling FWUP messages and errors By default, :hackney is used for completing HTTP requests and all FWUP messages are logged to STDOUT. To specify your own module to use, update your config.exs config :nerves_hub_link_http, client: MyApp.NervesHubLinkHTTP.Client","ref":"NervesHubLinkHTTP.Client.html","title":"NervesHubLinkHTTP.Client","type":"behaviour"},{"doc":"This function is called internally by NervesHubLinkHTTP to notify clients of fwup errors.","ref":"NervesHubLinkHTTP.Client.html#handle_error/1","title":"NervesHubLinkHTTP.Client.handle_error/1","type":"function"},{"doc":"Called when downloading a firmware update fails. The return value of this function is not checked.","ref":"NervesHubLinkHTTP.Client.html#c:handle_error/1","title":"NervesHubLinkHTTP.Client.handle_error/1","type":"callback"},{"doc":"This function is called internally by NervesHubLinkHTTP to notify clients of fwup progress.","ref":"NervesHubLinkHTTP.Client.html#handle_fwup_message/1","title":"NervesHubLinkHTTP.Client.handle_fwup_message/1","type":"function"},{"doc":"Called on firmware update reports. The return value of this function is not checked.","ref":"NervesHubLinkHTTP.Client.html#c:handle_fwup_message/1","title":"NervesHubLinkHTTP.Client.handle_fwup_message/1","type":"callback"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#me/0","title":"NervesHubLinkHTTP.Client.me/0","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#request/4","title":"NervesHubLinkHTTP.Client.request/4","type":"function"},{"doc":"Performs the HTTP request","ref":"NervesHubLinkHTTP.Client.html#c:request/5","title":"NervesHubLinkHTTP.Client.request/5","type":"callback"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#update/1","title":"NervesHubLinkHTTP.Client.update/1","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#url/1","title":"NervesHubLinkHTTP.Client.url/1","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:body/0","title":"NervesHubLinkHTTP.Client.body/0","type":"type"},{"doc":"Firmware update progress, completion or error report","ref":"NervesHubLinkHTTP.Client.html#t:fwup_message/0","title":"NervesHubLinkHTTP.Client.fwup_message/0","type":"type"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:header/0","title":"NervesHubLinkHTTP.Client.header/0","type":"type"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:method/0","title":"NervesHubLinkHTTP.Client.method/0","type":"type"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:opts/0","title":"NervesHubLinkHTTP.Client.opts/0","type":"type"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:response/0","title":"NervesHubLinkHTTP.Client.response/0","type":"type"},{"doc":"","ref":"NervesHubLinkHTTP.Client.html#t:url/0","title":"NervesHubLinkHTTP.Client.url/0","type":"type"},{"doc":"Default NervesHubLinkHTTP.Client implementation Requests are completed via :hackney FWUP messages are simply logged as warnings See NervesHugLinkHTTP.Client for more details.","ref":"NervesHubLinkHTTP.Client.Default.html","title":"NervesHubLinkHTTP.Client.Default","type":"module"},{"doc":"Agent used to keep the simple state of the devices connection to nerves-hub.org. The state is a tuple where the first element is an atom of :connected or :disconnected and the second element is the value of System.monotonic_time/1 at the time of setting the new state. In practice, this state is set after a HTTP request fails or succeeds. This makes it useful when you want to consider the connection to nerves-hub.org as part of the overall health of the device and perform explicit actions based on the result, such as using the Erlang :heart module to force a reboot if the callback check fails. # Set a callback for heart to check every 5 seconds. If the function returns anything other than # `:ok`, it will cause reboot. :heart.set_callback(NervesHub.Connection, :check!) Or, you can use the check as part of a separate function with other health checks as well defmodule MyApp.Checker do def health_check do with :ok &lt;- NervesHubLinkHTTP.Connection.check, :ok &lt;- MyApp.another_check, :ok &lt;- MyApp.yet_another_check, do :ok else err -&gt; err end end end # Somewhere else in MyApp :heart.set_callback(MyApp.Checker, :health_check)","ref":"NervesHubLinkHTTP.Connection.html","title":"NervesHubLinkHTTP.Connection","type":"module"},{"doc":"A simple check to see if the device is considered ok. This will still return :ok if the device is in a disconnected state, but within the :connection_timeout timeframe to allow for intermittent connection failures that are recoverable. Once the disconnection has exceeded the timeout, this check will be consided unhealthy. The default connection timeout is 15 minutes (900 seconds), but is configurable: # 60 second timeout config :nerves_hub_link_http, connection_timeout: 60","ref":"NervesHubLinkHTTP.Connection.html#check/0","title":"NervesHubLinkHTTP.Connection.check/0","type":"function"},{"doc":"Same as check/0, but raises RuntimeError if the check fails","ref":"NervesHubLinkHTTP.Connection.html#check!/0","title":"NervesHubLinkHTTP.Connection.check!/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"NervesHubLinkHTTP.Connection.html#child_spec/1","title":"NervesHubLinkHTTP.Connection.child_spec/1","type":"function"},{"doc":"Sets the state to {:connected, System.monotonic_time(:seconds)}","ref":"NervesHubLinkHTTP.Connection.html#connected/0","title":"NervesHubLinkHTTP.Connection.connected/0","type":"function"},{"doc":"Sets the state to {:disconnected, System.monotonic_time(:seconds)}","ref":"NervesHubLinkHTTP.Connection.html#disconnected/0","title":"NervesHubLinkHTTP.Connection.disconnected/0","type":"function"},{"doc":"Reads the state directly without modification.","ref":"NervesHubLinkHTTP.Connection.html#read/0","title":"NervesHubLinkHTTP.Connection.read/0","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.Connection.html#start_link/1","title":"NervesHubLinkHTTP.Connection.start_link/1","type":"function"},{"doc":"Download and install a firmware update.","ref":"NervesHubLinkHTTP.HTTPFwupStream.html","title":"NervesHubLinkHTTP.HTTPFwupStream","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#child_spec/1","title":"NervesHubLinkHTTP.HTTPFwupStream.child_spec/1","type":"function"},{"doc":"Download and install the firmware at the specified URL","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#get/2","title":"NervesHubLinkHTTP.HTTPFwupStream.get/2","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#get_header/2","title":"NervesHubLinkHTTP.HTTPFwupStream.get_header/2","type":"function"},{"doc":"","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#start/1","title":"NervesHubLinkHTTP.HTTPFwupStream.start/1","type":"function"},{"doc":"Start the downloader process A callback process should be passed Messages will be received in the shape: {:fwup_message, message} - see the docs for Fwup for more info. {:http_error, {status_code, body}} {:http_error, :timeout} {:http_error, :too_many_redirects}","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#start_link/1","title":"NervesHubLinkHTTP.HTTPFwupStream.start_link/1","type":"function"},{"doc":"Stop the downloader","ref":"NervesHubLinkHTTP.HTTPFwupStream.html#stop/1","title":"NervesHubLinkHTTP.HTTPFwupStream.stop/1","type":"function"},{"doc":"NervesHubLinkHTTP Official client to use HTTP polling for firmware updates from NervesHub","ref":"readme.html","title":"NervesHubLinkHTTP","type":"extras"},{"doc":"NervesHub is an open-source firmware update server that works well with Nerves-based devices. A managed version is available at nerves-hub.org and it&#39;s possible to host your own. NervesHub provides many of the features that you&#39;d expect in a firmware update server. Fundamentally, devices connect to the server either by polling at a pre-configured interval or by joining a long-lived Phoenix channel. If a firmware update is available, NervesHub will provide a URL to the device and the device can update immediately or when convenient. NervesHub does impose some requirements on devices and firmware that may require changes to your Nerves projects: Firmware images are cryptographically signed (both NervesHub and devices validate signatures) Devices are identified by a unique serial number Each device has its own SSL certificate for authentication with NervesHub These changes enable NervesHub to provide assurances that the firmware bits that you intend to install on a set of devices make it to those devices unaltered.","ref":"readme.html#overview","title":"NervesHubLinkHTTP - Overview","type":"extras"},{"doc":"The following sections will walk you through updating your Nerves project to work with the nerves-hub.org NervesHub server. Using your own NervesHub server will require setting URLs to point elsewhere and is not covered below to simplify first usage. Many of the steps below may feel manual, but they can and are automated by NervesHub users to set up automatic firmware updates from CI and to manufacture large numbers of devices. Creating an account on nerves-hub.org The nerves-hub.org NervesHub server is currently in limited beta so it does not allow new users to sign up. However, you found these docs and if you can use mix and endure some API changes, you can join us. In addition to the web site, NervesHub provides a command line interface (CLI). Some features are only available via the CLI. To enable the CLI in your project, addnerves_hub_cli to your dependency list: defp deps do [ {:nerves, &quot;~&gt; 1.3&quot;, runtime: false}, {:nerves_hub_cli, &quot;~&gt; 0.1&quot;, runtime: false} ... ] ++ deps(@target) end Run mix deps.get to download the nerves_hub_cli dependency. Presumably you do not have an account yet. Create one by running: mix nerves_hub.user register If you already have an account, make sure that you have authenticated by running: mix nerves_hub.user auth Adding NervesHubLinkHTTP to your project The first step is to add nerves_hub_link_http to your target dependencies in your project&#39;s mix.exs. Since NervesHub uses SSL certificates, the time must be set on the device or certificate validity checks will fail. If you&#39;re not already setting the time, add nerves_time to your dependencies. For example: defp deps(target) do [ {:nerves_runtime, &quot;~&gt; 0.9&quot;}, {:nerves_hub_link_http, &quot;~&gt; 0.1&quot;}, {:nerves_time, &quot;~&gt; 0.2&quot;}, ... ] ++ system(target) end Next, update your config.exs so that the nerves_hub_link_http library can help provision devices. Do this by adding provisioning: :nerves_hub_link_http to the :nerves, :firmware option like this: config :nerves, :firmware, provisioning: :nerves_hub_link_http You can now use NervesHubLinkHTTP.update/0 to request any available updates from NervesHub. Creating a NervesHub product A NervesHub product groups devices that run the same kind of firmware. All devices and firmware images have a product. NervesHub provides finer grain mechanisms for grouping devices, but a product is needed to get started. By default, NervesHub uses the :app name in your mix.exs for the product name. If you would like it to use a different name, add a :name field to your Mix.Project.config(). For example, NervesHub would use &quot;My Example&quot; instead of &quot;example&quot; for the following project: def project do [ app: :example, name: &quot;My Example&quot; ] end For the remainder of this document, though, we will not use the :name field and simply use the product name example. Create a new product on NervesHub by running: mix nerves_hub.product create Creating NervesHub firmware signing keys NervesHub requires cryptographic signatures on all managed firmware. Devices receiving firmware from NervesHub validate signatures. Since firmware is signed before uploading to NervesHub, NervesHub or any service NervesHub uses cannot modify it. Firmware authentication uses Ed25519 digital signatures. You need to create at least one public/private key pair and copy the public key part to NervesHub and to devices. NervesHub tooling helps with both. A typical setup has multiple signing keys to support key rotation and &quot;development&quot; keys that are not as protected. Start by creating a devkey firmware signing key pair: mix nerves_hub.key create devkey On success, you&#39;ll see the public key. You can confirm using the NervesHub web interface that the public key exists. Private keys are never sent to the NervesHub server. NervesHub requires valid signatures from known keys on all firmware it distributes. The next step is to make sure that the public key is embedded into the firmware image. This is important. The device uses this key to verify the firmware it receives from a NervesHub server before applying the update. This protects the device against anyone tampering with the firmware image between when it was signed by you and when it is installed. All firmware signing public keys need to be added to your config.exs. Keys that are stored locally (like the one we just created) can be referred to by their atom name: config :nerves_hub_link_http, fwup_public_keys: [:devkey] If you have keys that cannot be stored locally, you will have to copy/paste their public key: config :nerves_hub_link_http, fwup_public_keys: [ # devkey &quot;bM/O9+ykZhCWx8uZVgx0sU3f0JJX7mqnAVU9VGeuHr4=&quot; ] The nerves_hub_link_http dependency converts key names to public keys at compile time. If you haven&#39;t compiled your project yet, run mix firmware now. If you have compiled it, mix won&#39;t know to recompile nerves_hub_link_http due to the configuration change. Force it to recompile by running: mix deps.compile nerves_hub_link_http --force mix firmware While not shown here, you can export keys for safe storage. Additionally, key creation and firmware signing can be done outside of the mix tooling. The only part that is required is that the firmware signing public keys be added to your config.exs and to the NervesHub server. Publishing firmware Uploading firmware to NervesHub is called publishing. To publish firmware start by calling: mix firmware Firmware can only be published if has been signed. You can sign the firmware by running. mix nerves_hub.firmware sign --key devkey Firmware can also be signed while publishing: mix nerves_hub.firmware publish --key devkey Initializing devices In this example we will create a device with a hardware identifier 1234. The device will also be tagged with qa so we can target it in our deployment group. We will select y when asked if we would like to generate device certificates. Device certificates are required for a device to establish a connection with the NervesHub server. $ mix nerves_hub.device create NervesHub organization: nerveshub identifier: 1234 description: test-1234 tags: qa Local user password: Device 1234 created Would you like to generate certificates? [Yn] y Creating certificate for 1234 Finished It is important to note that device certificate private keys are generated and stay on your host computer. A certificate signing request is sent to the server, and a signed public key is passed back. Generated certificates will be placed in a folder titled nerves-hub in the current working directory. You can specify a different location by passing --path /path/to/certs to NervesHubCLI mix commands. NervesHub certificates and hardware identifiers are persisted to the firmware when the firmware is burned to the SD card. To make this process easier, you can call nerves_hub.device burn IDENTIFIER. In this example, we are going to burn the firmware and certificates for device 1234 that we created. mix nerves_hub.device burn 1234 Your device will now connect to NervesHub when it boots and establishes an network connection. Creating deployments Deployments associate firmware images to devices. NervesHub won&#39;t send firmware to a device until you create a deployment. First find the UUID of the firmware. You can list the firmware on NervesHub by calling: mix nerves_hub.firmware list Firmwares: ------------ product: example version: 0.3.0 platform: rpi3 architecture: arm uuid: 1cbecdbb-aa7d-5aee-4ba2-864d518417df In this example we will create a new deployment for our test group using firmware 1cbecdbb-aa7d-5aee-4ba2-864d518417df. mix nerves_hub.deployment create NervesHub organization: nerveshub Deployment name: qa_deployment firmware uuid: 1cbecdbb-aa7d-5aee-4ba2-864d518417df version condition: tags: qa Local user password: Deployment test created Here we create a new deployment called qa_deployment. In the conditions of this deployment we left the version condition unspecified and the tags set to only qa. This means that in order for a device to qualify for an update, it needs to have at least the tags [qa] and the device can be coming from any version. At this point we can try to update the connected device. Start by bumping the application version number from 0.1.0 to 0.1.1. Then, create new firmware: mix firmware We can publish, sign, and deploy firmware in a single command now. mix nerves_hub.firmware publish --key devkey --deploy qa_deployment","ref":"readme.html#getting-started","title":"NervesHubLinkHTTP - Getting Started","type":"extras"},{"doc":"TLS client errors If you see the following in your logs: 14:26:06.926 [info] [&#39;TLS&#39;, 32, &#39;client&#39;, 58, 32, 73, 110, 32, 115, 116, 97, 116, 101, 32, &#39;cipher&#39;, 32, &#39;received SERVER ALERT: Fatal - Unknown CA&#39;, 10] This probably indicates that the signing certificate hasn&#39;t been uploaded to nerves-hub.org so the device can&#39;t be authenticated. Double check that you ran: mix nerves_hub.ca_certificate register my-signer.cert Another possibility is that the device wasn&#39;t provisioned with the certificate that&#39;s on nerves-hub.org.","ref":"readme.html#debugging-errors","title":"NervesHubLinkHTTP - Debugging errors","type":"extras"}]